var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
import { createDecorator } from 'vue-class-component';
import { mapActions, mapGetters } from 'vuex';
export var Getter = function (getter) {
    return function (target, key) {
        var get = function () {
            var _a;
            var func = mapGetters((_a = {}, _a[key] = getter, _a))[key];
            return func.call.apply(func, __spread([this], arguments));
        };
        return createDecorator(function (options) {
            if (!options.computed)
                options.computed = {};
            options.computed[key] = get;
        })(target, key);
    };
};
export var Action = function (action) {
    return function (target, key) {
        var handler = function () {
            var _a;
            var func = mapActions((_a = {}, _a[key] = action, _a))[key];
            return func.call.apply(func, __spread([this], arguments));
        };
        return createDecorator(function (options) {
            if (!options.methods)
                options.methods = {};
            options.methods[key] = handler;
        })(target, key);
    };
};
//# sourceMappingURL=decorators.js.map